<script setup lang="ts">
import { ref, onMounted, reactive } from "vue";
import { useQuasar } from "quasar";

import { useRouter } from "vue-router";
import http from "@/plugins/http";
import config from "@/app.config";
import { useCounterMixin } from "@/stores/mixin";

/** importType*/
import type { QTableProps } from "quasar";
import type { ResGroup } from "@/modules/01_metadata/interface/response/positionEmployee/Main";
import type { FrmDataGroup } from "@/modules/01_metadata/interface/request/positionEmployee";

/** importComponents*/
import dialogHeader from "@/components/DialogHeader.vue";

const $q = useQuasar();
const router = useRouter();
const {
  dialogConfirm,
  success,
  messageError,
  showLoader,
  hideLoader,
  date2Thai,
  onSearchDataTable,
  dialogRemove,
} = useCounterMixin();

//Table
const rows = ref<ResGroup[]>([]); //รายการกลุ่มงาน
const rowsMain = ref<ResGroup[]>([]); //รายการกลุ่มงาน
const filterKeyword = ref<string>(""); //คำค้นหา
const columns = ref<QTableProps["columns"]>([
  {
    name: "posTypeName",
    align: "left",
    label: "กลุ่มงาน",
    sortable: true,
    field: "posTypeName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "posTypeShortName",
    align: "left",
    label: "อักษรย่อกลุ่มงาน",
    sortable: true,
    field: "posTypeShortName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "posTypeRank",
    align: "left",
    label: "ระดับกลุ่มงาน",
    sortable: true,
    field: "posTypeRank",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "createdAt",
    align: "left",
    label: "วันที่สร้าง",
    sortable: true,
    field: "createdAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      return date2Thai(val, false, true);
    },
  },
  {
    name: "lastUpdatedAt",
    align: "left",
    label: "วันที่แก้ไข",
    sortable: true,
    field: "lastUpdatedAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      return date2Thai(val, false, true);
    },
  },

  {
    name: "lastUpdateFullName",
    align: "left",
    label: "ผู้ดำเนินการ",
    sortable: true,
    field: "lastUpdateFullName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
]);
const visibleColumns = ref<string[]>([
  "posTypeName",
  "posTypeShortName",
  "posTypeRank",
  "createdAt",
  "lastUpdatedAt",
  "lastUpdateFullName",
]);

// ฟอร์มข้อมูลกลุ่มงาน
const formDataGroup = reactive<FrmDataGroup>({
  posTypeName: "",
  posTypeShortName: "",
  posTypeRank: null,
});

const editId = ref<string>("");
const dialog = ref<boolean>(false);
const dialogStatus = ref<string>("");

/**
 * ฟังก์ชันดึงข้อมูลรายการกลุ่มงาน API
 * เก็บข้อมูลรรายการกลุ่มงานไว้ใน rows.value
 */
async function fetchData() {
  showLoader();
  await http
    .get(config.API.orgEmployeeType)
    .then(async (res) => {
      rows.value = await res.data.result;
      rowsMain.value = await res.data.result;
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * ฟังก์ชันเปิด popup แก้ไขข้อมูลกลุ่มงาน
 * @param data ข้อมูลกลุ่มงานที่จะแก้ไข
 * กำหนด  dialogStatus เป็น edit และกำหนดให้ ฟอร์มข้อมูลกลุ่มงาน เป็น ข้อมูลที่จะแก่ไข
 */
function onClickOpenDialogEdit(data: ResGroup) {
  dialogStatus.value = "edit";
  dialog.value = true;
  editId.value = data.id;
  formDataGroup.posTypeName = data.posTypeName;
  formDataGroup.posTypeShortName = data.posTypeShortName;
  formDataGroup.posTypeRank = data.posTypeRank;
}

/**
 * ยืนยันการบันทึกข้อมูลรายการกลุ่มงาน
 * ุ ถ้า dialogStatus เป็น 'create' จะทำการเพิ่มข้อมูลรายการกลุ่มงาน ถ้าไม่จะทำการแก้ไขข้อมูล
 * เมื่อบันทึกข้อมูลเสร็จจะเรียก function fetchData() เพื่อดึงข้อมูลรายการกลุ่มงานใหม่
 *
 */
function onSubmit() {
  dialogConfirm($q, async () => {
    showLoader();
    const body: FrmDataGroup = {
      posTypeName: formDataGroup.posTypeName,
      posTypeShortName: formDataGroup.posTypeShortName,
      posTypeRank: Number(formDataGroup.posTypeRank),
    };
    // กำหนด Path API
    const url =
      dialogStatus.value === "create"
        ? config.API.orgEmployeeType
        : config.API.orgEmployeeTypeById(editId.value);
    await http[dialogStatus.value === "create" ? "post" : "put"](url, body)
      .then(async () => {
        await fetchData();
        success($q, "บันทีกข้อมูลสำเร็จ");
        closeDialog();
      })
      .catch((err) => {
        messageError($q, err);
      })
      .finally(() => {
        hideLoader();
      });
  });
}

/**
 * ลบข้อมูลรายการกลุ่มงาน
 * แล้ว fetch ข้อมูลรายการ ข้อมูลรายการกลุ่มงาน ใหม่
 * @param id ข้อมูลรายการกลุ่มงาน
 */
async function onDeleteData(id: string) {
  dialogRemove($q, async () => {
    showLoader();
    await http
      .delete(config.API.orgEmployeeTypeById(id))
      .then(async () => {
        await fetchData();
        success($q, "ลบข้อมูลสำเร็จ");
      })
      .catch((err) => {
        messageError($q, err);
      })
      .finally(() => {
        hideLoader();
      });
  });
}

/**
 * ฟังก์ชันไปหน้ารายการระดับชั้นงาน
 * @param id กลุ่มงาน
 */
function onClickDetail(id: string) {
  router.push(`/master-data/position-employee/level/${id}`);
}

/**
 * ฟังก์ชันปืด popup แก้ไขหรื่อเพิ่มข้อมูลกลุ่มงาน
 * และกำหนดให้ ฟอร์มข้อมูลกลุ่มงาน เป็นค่าว่าง
 */
function closeDialog() {
  dialog.value = false;
  formDataGroup.posTypeName = "";
  formDataGroup.posTypeShortName = "";
  formDataGroup.posTypeRank = null;
}

function serchDataTable() {
  rows.value = onSearchDataTable(
    filterKeyword.value,
    rowsMain.value,
    columns.value ? columns.value : []
  );
}

/**
 * hook ทำงานเมื่อ Components ถูกเรียกใช้งาน
 */
onMounted(async () => {
  await fetchData();
});
</script>

<template>
  <q-toolbar style="padding: 0">
    <q-btn
      flat
      round
      color="primary"
      icon="add"
      @click.stop="
        () => {
          dialogStatus = 'create';
          dialog = true;
        }
      "
    >
      <q-tooltip> เพิ่มข้อมูล </q-tooltip>
    </q-btn>
    <q-space />
    <div class="row q-gutter-sm">
      <q-input
        dense
        outlined
        v-model="filterKeyword"
        placeholder="ค้นหา"
        @keydown.enter.prevent="serchDataTable"
      >
        <template v-slot:append>
          <q-icon name="search" />
        </template>
      </q-input>
      <q-select
        v-model="visibleColumns"
        multiple
        outlined
        dense
        options-dense
        :display-value="$q.lang.table.columns"
        emit-value
        map-options
        :options="columns"
        option-value="name"
        style="min-width: 140px"
      />
    </div>
  </q-toolbar>

  <d-table
    ref="table"
    :columns="columns"
    :rows="rows"
    row-key="name"
    flat
    bordered
    :paging="true"
    dense
    class="custom-header-table"
    :rows-per-page-options="[10, 20, 50, 100]"
    :visible-columns="visibleColumns"
  >
    <template v-slot:header="props">
      <q-tr :props="props">
        <q-th auto-width />
        <q-th v-for="col in props.cols" :key="col.name" :props="props">
          <span class="text-weight-medium">{{ col.label }}</span>
        </q-th>
      </q-tr>
    </template>
    <template v-slot:body="props">
      <q-tr
        :props="props"
        class="cursor-pointer"
        @click.stop="onClickDetail(props.row.id)"
      >
        <q-td auto-width>
          <q-btn
            color="edit"
            flat
            dense
            round
            icon="edit"
            @click.stop="onClickOpenDialogEdit(props.row)"
          >
            <q-tooltip>แก้ไขข้อมูล</q-tooltip>
          </q-btn>
          <q-btn
            color="red"
            flat
            dense
            round
            icon="delete"
            @click.stop.prevent="onDeleteData(props.row.id)"
          >
            <q-tooltip>ลบข้อมูล</q-tooltip>
          </q-btn>
        </q-td>
        <q-td v-for="col in props.cols" :key="col.id">
          {{ col.value ? col.value : "-" }}
        </q-td>
      </q-tr>
    </template>
  </d-table>

  <q-dialog v-model="dialog" class="dialog" persistent>
    <q-card style="width: 350px">
      <q-form greedy @submit.prevent @validation-success="onSubmit">
        <q-card-section class="flex justify-between" style="padding: 0">
          <dialog-header
            :tittle="
              dialogStatus === 'edit'
                ? 'แก้ไขข้อมูลกลุ่มงาน'
                : 'เพิ่มข้อมูลกลุ่มงาน'
            "
            :close="closeDialog"
          />
        </q-card-section>

        <q-separator color="grey-4" />
        <q-card-section class="row q-gutter-y-md">
          <div class="col-12">
            <q-input
              ref="posTypeNameRef"
              outlined
              v-model="formDataGroup.posTypeName"
              label="ชื่อกลุ่มงาน"
              dense
              lazy-rules
              borderless
              bg-color="white"
              :rules="[(val:string) => val.length > 0 || 'กรุณากรอกชื่อกลุ่มงาน']"
              hide-bottom-space
              class="inputgreen"
            />
          </div>

          <div class="col-12">
            <q-input
              ref="posTypeShortNameRef"
              v-model="formDataGroup.posTypeShortName"
              dense
              outlined
              for="#positionShortName"
              label="อักษรย่อกลุ่มงาน"
              lazy-rules
              hide-bottom-space
              :rules="[(val:string) => !!val || `${'กรุณากรอกอักษรย่อกลุ่มงาน'}`]"
              class="inputgreen"
            />
          </div>

          <div class="col-12">
            <q-input
              ref="posTypeRankRef"
              outlined
              v-model="formDataGroup.posTypeRank"
              label="ระดับกลุ่มงาน"
              dense
              lazy-rules
              borderless
              min="1"
              bg-color="white"
              :rules="[(val:string) => val != undefined || 'กรุณากรอกระดับกลุ่มงาน']"
              hide-bottom-space
              mask="############"
              class="inputgreen"
            />
          </div>
        </q-card-section>
        <q-separator />
        <q-card-actions align="right">
          <q-btn id="onSubmit" type="submit" label="บันทึก" color="public">
            <q-tooltip>บันทึกข้อมูล</q-tooltip>
          </q-btn>
        </q-card-actions>
      </q-form>
    </q-card>
  </q-dialog>
</template>

<style scoped lang="scss"></style>
